<?php
/***************************************************** 
 *                System biblioteczny                * 
 ***************************************************** 
 * Wersja: 1.02 Stable                               * 
 * Data: 20.02.2009 (16:48)                          * 
 * Autor: Jacek Kowalski (http://jacekk.info)        * 
 *                                                   * 
 * Utwor rozprowadzany na licencji                   * 
 * http://creativecommons.org/licenses/by-nc-sa/2.5/ * 
 *****************************************************/

class ksiazki {
	static $LT_API = '';
	
	static $cache = array();
	
	static function okladka($KOD, $ISBN) {
		if(!function_exists('curl_init')) {
			return FALSE;
		}
		
		if(strlen($ISBN)==13) {
			validate::EAN($ISBN);
			
			if(substr($ISBN, 0, 3)=='978') {
				$ISBN10 = convert::ISBN13_to_ISBN10($ISBN);
			}
			else
			{
				$ISBN10 = $ISBN;
			}
		}
		elseif(strlen($KOD)<=8 && ctype_digit($KOD)) {
			validate::KOD($KOD);
			
			if(!file_exists('./covers/own/'.$KOD)) {
				return FALSE;
			}
			else
			{
				return './covers/own/'.$KOD;
			}
		}
		else
		{
			return FALSE;
		}
		
		if(file_exists('./covers/own/'.$ISBN)) {
			return './covers/own/'.$ISBN;
		}
		elseif(!file_exists('./covers/'.$ISBN) || (filesize('./covers/'.$ISBN)==0 AND filemtime('./covers/'.$ISBN)+2592000 < time())) {
			$get = 'http://www.librarything.com/devkey/'.self::$LT_API.'/small/isbn/'.$ISBN10;
			$curl = curl_init($get);
			curl_setopt($curl, CURLOPT_FOLLOWLOCATION, TRUE);
			curl_setopt($curl, CURLOPT_RETURNTRANSFER, TRUE);
			
			$img = @curl_exec($curl);
			$code = curl_getinfo($curl, CURLINFO_HTTP_CODE);
			$type = curl_getinfo($curl, CURLINFO_CONTENT_TYPE);
			if($code != 200 || substr($type, 0, 6) != 'image/' || $img == FALSE || strlen($img) < 100) {
				touch('./covers/'.$ISBN);
				return FALSE;
			}
			else
			{
				file_put_contents('./covers/'.$ISBN, $img);
				return './covers/'.$ISBN;
			}
		}
		elseif(file_exists('./covers/'.$ISBN) AND filesize('./covers/'.$ISBN)>100) {
			return './covers/'.$ISBN;
		}
		
		return FALSE;
	}
	
	static function okladka_big($KOD, $ISBN) {
		if(!function_exists('curl_init')) {
			return FALSE;
		}
		
		if(strlen($ISBN)==13) {
			validate::EAN($ISBN);
			
			if(substr($ISBN, 0, 3)=='978') {
				$ISBN10 = convert::ISBN13_to_ISBN10($ISBN);
			}
			else
			{
				$ISBN10 = $ISBN;
			}
		}
		elseif(strlen($KOD)<=8 && ctype_digit($KOD)) {
			validate::KOD($KOD);
			
			if(!file_exists('./covers_big/own/'.$KOD)) {
				return FALSE;
			}
			else
			{
				return './covers_big/own/'.$KOD;
			}
		}
		else
		{
			return FALSE;
		}
		
		if(file_exists('./covers_big/own/'.$ISBN)) {
			return './covers_big/own/'.$ISBN;
		}
		elseif((file_exists('./covers/'.$ISBN) && !file_exists('./covers_big/'.$ISBN)) || (file_exists('./covers_big/'.$ISBN) AND filesize('./covers_big/'.$ISBN)==0 AND filemtime('./covers_big/'.$ISBN)+2592000 < time())) {
			$get = 'http://www.librarything.com/devkey/'.self::$LT_API.'/large/isbn/'.$ISBN10;
			$curl = curl_init($get);
			curl_setopt($curl, CURLOPT_FOLLOWLOCATION, TRUE);
			curl_setopt($curl, CURLOPT_RETURNTRANSFER, TRUE);
			
			$img = curl_exec($curl);
			$code = curl_getinfo($curl, CURLINFO_HTTP_CODE);
			$type = curl_getinfo($curl, CURLINFO_CONTENT_TYPE);
			if($code != 200 || substr($type, 0, 6) != 'image/' || $img == FALSE || strlen($img) < 100) {
				touch('./covers_big/'.$ISBN);
				return FALSE;
			}
			else
			{
				file_put_contents('./covers_big/'.$ISBN, $img);
				return './covers_big/'.$ISBN;
			}
		}
		elseif(file_exists('./covers_big/'.$ISBN) AND filesize('./covers_big/'.$ISBN)>100) {
			return './covers_big/'.$ISBN;
		}
		return FALSE;
	}
	
	static function img_resize($file, $type, $max_width, $max_height, $outfile) {
		list($width, $height) = getimagesize($file);
		
		if ($width > $max_width OR $height > $max_height) {
			if($width*$max_height > $height*$max_width) {
				$new_width = $max_width;
				$new_height = round( ($new_width / $width) * $height );
			}
			else
			{
				$new_height = $max_height;
				$new_width = round( ($new_height / $height) * $width );
			}
			
			$new_image = imagecreatetruecolor($new_width, $new_height);
			switch(strtolower($type)) {
				case 'jpg':
				case 'jpeg':
					$image = imagecreatefromjpeg($file);
				break;
				case 'png':
					$image = imagecreatefrompng($file);
				break;
				case 'gif':
					$image = imagecreatefromgif($file);
				break;
				default:
					error::add('Nieznany format obrazka!');
					return FALSE;
				break;
			}
			
			imagecopyresampled($new_image, $image, 0, 0, 0, 0, $new_width, $new_height, $width, $height);
			imagejpeg($new_image, $outfile, 100);
		}
		else
		{
			copy($file, $outfile);
			return TRUE;
		}
	}
	
	static function dodaj(&$dane) {
		validate::KOD($dane['id'], FALSE);
		
		if($dane['ISBN']) {
			$t = validate::type($dane['ISBN']);
			if($t!='ISBN') {
				error::add('W polu ISBN znajduje się '.$t);
			}
		}
		if($dane['ISSN']) {
			$t = validate::type($dane['ISSN']);
			if($t!='ISSN') {
				error::add('W polu ISSN znajduje się '.$t);
			}
		}
		
		if($dane['jezyk']=='pol') {
			$dane['jezyk'] = 'polski';
		}
		
		unset($_POST['okladka']);
		
		if(isset($_FILES['okladka']) && is_uploaded_file($_FILES['okladka']['tmp_name'])) {
			if($dane['ISBN']) {
				self::img_resize($_FILES['okladka']['tmp_name'], substr($_FILES['okladka']['name'], strrpos($_FILES['okladka']['name'], '.')+1), 500, 500, './covers_big/own/'.$dane['ISBN']);
				self::img_resize($_FILES['okladka']['tmp_name'], substr($_FILES['okladka']['name'], strrpos($_FILES['okladka']['name'], '.')+1), 53, 80, './covers/own/'.$dane['ISBN']);
				if(file_exists('./covers/'.$dane['ISBN'])) {
					unlink('./covers/'.$dane['ISBN']);
				}
			}
			else
			{
				self::img_resize($_FILES['okladka']['tmp_name'], substr($_FILES['okladka']['name'], strrpos($_FILES['okladka']['name'], '.')+1), 500, 500, './covers_big/own/'.$dane['id']);
				self::img_resize($_FILES['okladka']['tmp_name'], substr($_FILES['okladka']['name'], strrpos($_FILES['okladka']['name'], '.')+1), 53, 80, './covers/own/'.$dane['id']);
			}
		}
		
		db2::add('ksiazki', $dane);
		self::cache_update($dane['id']);
	}
	
	static function exists($kod) {
		$info = self::cache_get($kod);
		if(isset($info['id'])) {
			return TRUE;
		}
		else
		{
			return FALSE;
		}
	}
	
	static function cache_get($kod) {
		$kod = (int)$kod;
		
		if(!isset(self::$cache[(int)$kod])) {
			self::cache_update($kod);
		}
		
		return self::$cache[(int)$kod];
	}
	
	static function cache_add($kod, &$dane) {
		if($dane['od2']) {
			$dane['od'] = $dane['od2'];
			unset($dane['od2']);
		}
		self::$cache[(int)$kod] = $dane;
	}
	
	static function cache_addarray(&$dane) {
		foreach($dane as &$r) {
			self::cache_add($r['id'], $r);
		}
	}
	
	static function cache_clear($id=NULL) {
		if(is_null($id)) {
			self::$cache = array();
		}
		else
		{
			unset(self::$cache[(int)$id]);
		}
	}
	
	static function edytuj(&$dane) {
		validate::KOD($dane['id']);
		$kod = $dane['id'];
		
		$old = self::szukaj_KOD($kod);
		
		if($dane['id']=='' OR empty($dane['autor']) OR empty($dane['tytul']) OR empty($dane['jezyk'])) {
			error::add('Brak wymaganych danych o książce (kod, autor, tytuł, język)');
		}
		
		if($dane['nid']!='') {
			validate::KOD($dane['nid']);
			$dane['id'] = $dane['nid'];
		}
		
		unset($dane['nid']);
		
		if($dane['ISBN']) {
			$t = validate::type($dane['ISBN']);
			if($t!='ISBN') {
				error::add('W polu ISBN znajduje się '.$t);
			}
		}
		if($dane['ISSN']) {
			$t = validate::type($dane['ISSN']);
			if($t!='ISSN') {
				error::add('W polu ISSN znajduje się '.$t);
			}
		}
		
		if(!$dane['wycofana']) {
			$dane['wycofana'] = 0;
			$dane['powod'] = NULL;
		}
		
		// Przenoszenie okładki
		if(empty($old['ISBN']) && !empty($dane['ISBN']) && file_exists('./covers/own/'.$old['id'])) {
			rename('./covers/own/'.$old['id'], './covers/own/'.$dane['ISBN']);
			if(file_exists('./covers_big/own/'.$old['id'])) {
				rename('./covers_big/own/'.$old['id'], './covers_big/own/'.$dane['ISBN']);
			}
		}
		elseif($dane['id'] != $old['id'] && file_exists('./covers/own/'.$old['id'])) {
			rename('./covers/own/'.$old['id'], './covers/own/'.$dane['id']);
			if(file_exists('./covers_big/own/'.$old['id'])) {
				rename('./covers_big/own/'.$old['id'], './covers_big/own/'.$dane['id']);
			}
		}
		elseif($dane['ISBN'] != $old['ISBN']) {
			if(file_exists('./covers/'.$old['ISBN'])) {
				rename('./covers/'.$old['ISBN'], './covers/'.$dane['ISBN']);
				if(file_exists('./covers_big/'.$old['ISBN'])) {
					rename('./covers_big/'.$old['ISBN'], './covers_big/'.$dane['ISBN']);
				}
			}
			elseif(file_exists('./covers/own/'.$old['ISBN'])) {
				rename('./covers/own/'.$old['ISBN'], './covers/own/'.$dane['ISBN']);
				if(file_exists('./covers_big/own/'.$old['ISBN'])) {
					rename('./covers_big/own/'.$old['ISBN'], './covers_big/own/'.$dane['ISBN']);
				}
			}
		}
		
		unset($_POST['okladka']);
		
		// Nowa okładka
		if(isset($_FILES['okladka']) && is_uploaded_file($_FILES['okladka']['tmp_name'])) {
			if($dane['ISBN']) {
				if(file_exists('./covers/'.$dane['ISBN'])) {
					unlink('./covers/'.$dane['ISBN']);
					if(file_exists('./covers_big/'.$dane['ISBN'])) {
						unlink('./covers_big/'.$dane['ISBN']);
					}
				}
				elseif(file_exists('./covers/own/'.$dane['ISBN'])) {
					unlink('./covers/own/'.$dane['ISBN']);
					if(file_exists('./covers_big/own/'.$dane['ISBN'])) {
						unlink('./covers_big/own/'.$dane['ISBN']);
					}
				}
				
				self::img_resize($_FILES['okladka']['tmp_name'], substr($_FILES['okladka']['name'], strrpos($_FILES['okladka']['name'], '.')+1), 500, 500, './covers_big/own/'.$dane['ISBN']);
				self::img_resize($_FILES['okladka']['tmp_name'], substr($_FILES['okladka']['name'], strrpos($_FILES['okladka']['name'], '.')+1), 53, 80, './covers/own/'.$dane['ISBN']);
			}
			else
			{
				if(file_exists('./covers/own/'.$dane['id'])) {
					unlink('./covers/own/'.$dane['id']);
					if(file_exists('./covers_big/own/'.$dane['id'])) {
						unlink('./covers_big/own/'.$dane['id']);
					}
				}
				self::img_resize($_FILES['okladka']['tmp_name'], substr($_FILES['okladka']['name'], strrpos($_FILES['okladka']['name'], '.')+1), 500, 500, './covers_big/own/'.$dane['id']);
				self::img_resize($_FILES['okladka']['tmp_name'], substr($_FILES['okladka']['name'], strrpos($_FILES['okladka']['name'], '.')+1), 53, 80, './covers/own/'.$dane['id']);
			}
		}
		
		db2::edit('ksiazki', $dane, array('id' => $kod));
		self::cache_update($kod);
		if($dane['id']!=$kod) {
			self::cache_update($dane['id']);
		}
	}
	
	static function miejsce($regal, $polka, $rzad, $where) {
		db2::edit('ksiazki', array('regal' => strtoupper($regal), 'polka' => $polka, 'rzad' => $rzad), $where);
		self::cache_clear();
	}
	
	static function usun(&$kod) {
		validate::KOD($kod);
		
		$dane = self::szukaj_KOD($kod);
		
		// Usuwanie okładki
		if($dane['ISBN']) {
			if(file_exists('./covers/'.$dane['ISBN'])) {
				unlink('./covers/'.$dane['ISBN']);
				if(file_exists('./covers_big/'.$dane['ISBN'])) {
					unlink('./covers_big/'.$dane['ISBN']);
				}
			}
			elseif(file_exists('./covers/own/'.$dane['ISBN'])) {
				unlink('./covers/own/'.$dane['ISBN']);
				if(file_exists('./covers_big/own/'.$dane['ISBN'])) {
					unlink('./covers_big/own/'.$dane['ISBN']);
				}
			}
		}
		else
		{
			if(file_exists('./covers/own/'.$kod)) {
				unlink('./covers/own/'.$kod);
				if(file_exists('./covers_big/own/'.$kod)) {
					unlink('./covers_big/own/'.$kod);
				}
			}
		}
		
		db2::del('ksiazki', array('id' => $kod));
		self::cache_clear($kod);
	}
	
	static function cache_update($kod) {
		self::cache_add($kod, sql::fetchone(sql::query('SELECT *, (SELECT MAX(`od`) FROM `pozycz` WHERE `pozycz`.`id`=`ksiazki`.`id`) as `od2`, (SELECT `do` FROM `pozycz` WHERE `pozycz`.`id`=`ksiazki`.`id` AND `od`=`od2`) as `do`, (SELECT `kto` FROM `pozycz` WHERE `pozycz`.`id`=`ksiazki`.`id` AND `od`=`od2`) as `kto` FROM `ksiazki` WHERE `id`=\''.sql::escape($kod).'\'')));
	}
	
	static function szukaj_KOD($kod) {
		validate::KOD($kod, TRUE);
		
		return self::cache_get($kod);
	}
	
	static function szukaj_ISBN($ISBN) {
		validate::EAN($ISBN);
		
		return db2::get('ksiazki', '*', array('ISBN' => $ISBN), NULL, 10);
	}
	
	static function szukaj_ISSN($ISSN) {
		validate::EAN($ISSN);
		
		return db2::get('ksiazki', '*', array('ISSN' => $ISSN), NULL, 10);
	}
	
	static function szukaj_info($dane, $order=NULL, $start=NULL, $limit=30) {
		$allow = array('id', 'tytul', 'autor', 'wydawnictwo', 'miejsce', 'rok', 'wydanie', 'wycofana');
		$replace = array('tytul' => 'tytul~~', 'autor' => 'autor~~', 'wydawnictwo' => 'wydawnictwo~~');
		
		$where = array();
		
		foreach($dane as $key => $value) {
			if(!in_array($key, $allow) OR $value==='') {
				continue;
			}
			
			if($replace[$key]) {
				$key = $replace[$key];
			}
			
			$where[$key] = $value;
		}
		
		if($where['id']) {
			validate::$kod = TRUE;
			switch(validate::type($where['id'])) {
				case 'ISBN':
					$where['ISBN'] = $where['id'];
					unset($where['id']);
				break;
				case 'ISSN':
					$where['ISBN'] = $where['id'];
					unset($where['id']);
				break;
				case 'MSC':
					$where['regal'] = $where['id'];
					if($where['polka']) {
						$where['polka'] = $dane['polka'];
					}
					if($where['rzad']) {
						$where['rzad'] = $dane['rzad'];
					}
					unset($where['id']);
				break;
			}
			validate::$kod = FALSE;
		}
		
		if(!$where['regal']) {
			unset($where['polka']);
			unset($where['rzad']);
		}
		
		if($where['id']) {
			$ret[] = self::szukaj_KOD($where['id']);
			$num = count($ret);
		}
		else
		{
			if($dane['do']) {
				$num = db2::num('pozycz', 'id', array('do' => NULL));
				if($num==0) {
					$ret = array();
				}
				else
				{
					$ret = db2::get(array('ksiazki', array('L', 'pozycz', 'USING', 'id')), '*', array('od!' => NULL, 'do' => NULL), $order, $start, $limit);
				}
			}
			else
			{
				$num = db2::num('ksiazki', 'id', $where);
				if($num==0) {
					$ret = array();
				}
				else
				{
					$ret = sql::fetch(sql::query('SELECT *, (SELECT MAX(`od`) FROM `pozycz` WHERE `pozycz`.`id`=`ksiazki`.`id`) as `od2`, (SELECT `do` FROM `pozycz` WHERE `pozycz`.`id`=`ksiazki`.`id` AND `od`=`od2`) as `do`, (SELECT `kto` FROM `pozycz` WHERE `pozycz`.`id`=`ksiazki`.`id` AND `od`=`od2`) as `kto`  FROM `ksiazki`'.db2::__combine_where($where).db2::__combine_order($order).db2::__combine_limit($start, $limit)));
				}
			}
			
			self::cache_addarray($ret);
		}
		
		return array($num, $ret, db2::revelance());
	}
}
?>
